searchData={"items":[{"type":"module","title":"erldns","doc":"Convenience API to start erl-dns directly.","ref":"erldns.html"},{"type":"function","title":"erldns.normalize_name/1","doc":"Converts a domain name to lower case.","ref":"erldns.html#normalize_name/1"},{"type":"function","title":"erldns.start/0","doc":null,"ref":"erldns.html#start/0"},{"type":"type","title":"erldns.keyset/0","doc":null,"ref":"erldns.html#t:keyset/0"},{"type":"type","title":"erldns.zone/0","doc":null,"ref":"erldns.html#t:zone/0"},{"type":"module","title":"erldns_app","doc":"The erldns OTP application.","ref":"erldns_app.html"},{"type":"function","title":"erldns_app.start/2","doc":null,"ref":"erldns_app.html#start/2"},{"type":"function","title":"erldns_app.start_phase/3","doc":null,"ref":"erldns_app.html#start_phase/3"},{"type":"function","title":"erldns_app.stop/1","doc":null,"ref":"erldns_app.html#stop/1"},{"type":"module","title":"erldns_axfr","doc":"Implementation of AXFR with IP address whitelisting required.","ref":"erldns_axfr.html"},{"type":"function","title":"erldns_axfr.is_enabled/2","doc":null,"ref":"erldns_axfr.html#is_enabled/2"},{"type":"function","title":"erldns_axfr.optionally_append_soa/1","doc":null,"ref":"erldns_axfr.html#optionally_append_soa/1"},{"type":"module","title":"erldns_config","doc":"Provide application-wide configuration access.","ref":"erldns_config.html"},{"type":"function","title":"erldns_config.get_address/1","doc":"Get the IP address (either IPv4 or IPv6) that the DNS server should listen on. IPv4 default: 127.0.0.1 IPv6 default: ::1","ref":"erldns_config.html#get_address/1"},{"type":"function","title":"erldns_config.get_num_workers/0","doc":"Get the number of workers to run for handling DNS requests. Default: 10","ref":"erldns_config.html#get_num_workers/0"},{"type":"function","title":"erldns_config.get_port/0","doc":"The the port that the DNS server should listen on. Default: 53","ref":"erldns_config.html#get_port/0"},{"type":"function","title":"erldns_config.get_servers/0","doc":null,"ref":"erldns_config.html#get_servers/0"},{"type":"function","title":"erldns_config.ingress_tcp_request_timeout/0","doc":null,"ref":"erldns_config.html#ingress_tcp_request_timeout/0"},{"type":"function","title":"erldns_config.ingress_udp_request_timeout/0","doc":null,"ref":"erldns_config.html#ingress_udp_request_timeout/0"},{"type":"function","title":"erldns_config.keyget/2","doc":null,"ref":"erldns_config.html#keyget/2"},{"type":"function","title":"erldns_config.keyget/3","doc":null,"ref":"erldns_config.html#keyget/3"},{"type":"function","title":"erldns_config.packet_cache_default_ttl/0","doc":null,"ref":"erldns_config.html#packet_cache_default_ttl/0"},{"type":"function","title":"erldns_config.packet_cache_enabled/0","doc":null,"ref":"erldns_config.html#packet_cache_enabled/0"},{"type":"function","title":"erldns_config.packet_cache_sweep_interval/0","doc":null,"ref":"erldns_config.html#packet_cache_sweep_interval/0"},{"type":"function","title":"erldns_config.packet_cache_ttl_overrides/0","doc":null,"ref":"erldns_config.html#packet_cache_ttl_overrides/0"},{"type":"function","title":"erldns_config.storage_dir/0","doc":null,"ref":"erldns_config.html#storage_dir/0"},{"type":"function","title":"erldns_config.storage_env/0","doc":null,"ref":"erldns_config.html#storage_env/0"},{"type":"function","title":"erldns_config.storage_host/0","doc":null,"ref":"erldns_config.html#storage_host/0"},{"type":"function","title":"erldns_config.storage_pass/0","doc":null,"ref":"erldns_config.html#storage_pass/0"},{"type":"function","title":"erldns_config.storage_port/0","doc":null,"ref":"erldns_config.html#storage_port/0"},{"type":"function","title":"erldns_config.storage_type/0","doc":null,"ref":"erldns_config.html#storage_type/0"},{"type":"function","title":"erldns_config.storage_user/0","doc":null,"ref":"erldns_config.html#storage_user/0"},{"type":"function","title":"erldns_config.use_root_hints/0","doc":null,"ref":"erldns_config.html#use_root_hints/0"},{"type":"function","title":"erldns_config.websocket_env/0","doc":null,"ref":"erldns_config.html#websocket_env/0"},{"type":"function","title":"erldns_config.websocket_host/0","doc":null,"ref":"erldns_config.html#websocket_host/0"},{"type":"function","title":"erldns_config.websocket_path/0","doc":null,"ref":"erldns_config.html#websocket_path/0"},{"type":"function","title":"erldns_config.websocket_port/0","doc":null,"ref":"erldns_config.html#websocket_port/0"},{"type":"function","title":"erldns_config.websocket_protocol/0","doc":null,"ref":"erldns_config.html#websocket_protocol/0"},{"type":"function","title":"erldns_config.websocket_url/0","doc":null,"ref":"erldns_config.html#websocket_url/0"},{"type":"function","title":"erldns_config.zone_server_env/0","doc":null,"ref":"erldns_config.html#zone_server_env/0"},{"type":"function","title":"erldns_config.zone_server_host/0","doc":null,"ref":"erldns_config.html#zone_server_host/0"},{"type":"function","title":"erldns_config.zone_server_max_processes/0","doc":null,"ref":"erldns_config.html#zone_server_max_processes/0"},{"type":"function","title":"erldns_config.zone_server_port/0","doc":null,"ref":"erldns_config.html#zone_server_port/0"},{"type":"function","title":"erldns_config.zone_server_protocol/0","doc":null,"ref":"erldns_config.html#zone_server_protocol/0"},{"type":"module","title":"erldns_decoder","doc":"Safe response decoding, where exceptions will not result in a full system crash","ref":"erldns_decoder.html"},{"type":"function","title":"erldns_decoder.decode_message/1","doc":"Decode the binary data into its Erlang representation. Note that if the erldns catch_exceptions property is set in the configuration, then this function should never throw an exception.","ref":"erldns_decoder.html#decode_message/1"},{"type":"module","title":"erldns_dnssec","doc":"Placeholder for eventual DNSSEC implementation.","ref":"erldns_dnssec.html"},{"type":"function","title":"erldns_dnssec.handle/4","doc":"Apply DNSSEC records to the given message if the zone is signed and DNSSEC is requested.","ref":"erldns_dnssec.html#handle/4"},{"type":"function","title":"erldns_dnssec.key_rrset_signer/2","doc":"Return a function that can be used to sign the given records using the key signing key. The function accepts a keyset, allowing the zone signing mechanism to iterate through available keysets, applying the key signing key from each keyset.","ref":"erldns_dnssec.html#key_rrset_signer/2"},{"type":"function","title":"erldns_dnssec.map_nsec_rr_types/1","doc":null,"ref":"erldns_dnssec.html#map_nsec_rr_types/1"},{"type":"function","title":"erldns_dnssec.maybe_sign_rrset/3","doc":"This function will potentially sign the given RR set if the following conditions are true: - DNSSEC is requested - The zone is signed","ref":"erldns_dnssec.html#maybe_sign_rrset/3"},{"type":"function","title":"erldns_dnssec.rrsig_for_zone_rrset/2","doc":"Given a zone and a set of records, return the RRSIG records.","ref":"erldns_dnssec.html#rrsig_for_zone_rrset/2"},{"type":"function","title":"erldns_dnssec.zone_rrset_signer/2","doc":"Return a function that can be used to sign the given records using the zone signing key. The function accepts a keyset, allowing the zone signing mechanism to iterate through available keysets, applying the zone signing key from each keyset.","ref":"erldns_dnssec.html#zone_rrset_signer/2"},{"type":"module","title":"erldns_edns","doc":"EDNS0 implementation.","ref":"erldns_edns.html"},{"type":"function","title":"erldns_edns.get_opts/1","doc":"Get a property list of EDNS0 options. Supported options are: * {dnssec, true}","ref":"erldns_edns.html#get_opts/1"},{"type":"module","title":"erldns_encoder","doc":"Safe response encoding, where exceptions will not result in a full system crash.","ref":"erldns_encoder.html"},{"type":"function","title":"erldns_encoder.encode_message/1","doc":"Encode the DNS message into its binary representation. Note that if the erldns catch_exceptions property is set in the configuration, then this function should never throw an exception.","ref":"erldns_encoder.html#encode_message/1"},{"type":"function","title":"erldns_encoder.encode_message/2","doc":"Encode the DNS message into its binary representation. Use the Opts argument to pass in encoding options. Note that if the erldns catch_exceptions property is set in the configuration, then this function should never throw an exception.","ref":"erldns_encoder.html#encode_message/2"},{"type":"module","title":"erldns_event_handler","doc":"Application event handler implementation.","ref":"erldns_event_handler.html"},{"type":"function","title":"erldns_event_handler.code_change/3","doc":null,"ref":"erldns_event_handler.html#code_change/3"},{"type":"function","title":"erldns_event_handler.handle_call/2","doc":null,"ref":"erldns_event_handler.html#handle_call/2"},{"type":"function","title":"erldns_event_handler.handle_event/2","doc":null,"ref":"erldns_event_handler.html#handle_event/2"},{"type":"function","title":"erldns_event_handler.handle_info/2","doc":null,"ref":"erldns_event_handler.html#handle_info/2"},{"type":"function","title":"erldns_event_handler.init/1","doc":null,"ref":"erldns_event_handler.html#init/1"},{"type":"function","title":"erldns_event_handler.terminate/2","doc":null,"ref":"erldns_event_handler.html#terminate/2"},{"type":"module","title":"erldns_events","doc":"Public API for erldns event handler registration and notification.","ref":"erldns_events.html"},{"type":"function","title":"erldns_events.add_handler/1","doc":"Add an event handler.","ref":"erldns_events.html#add_handler/1"},{"type":"function","title":"erldns_events.add_handler/2","doc":"Add an event handler with arguments.","ref":"erldns_events.html#add_handler/2"},{"type":"function","title":"erldns_events.notify/1","doc":"Fire an event.","ref":"erldns_events.html#notify/1"},{"type":"function","title":"erldns_events.start_link/0","doc":"Start the event process.","ref":"erldns_events.html#start_link/0"},{"type":"module","title":"erldns_handler","doc":"The module that handles the resolution of a single DNS question. The meat of the resolution occurs in erldns_resolver:resolve/3","ref":"erldns_handler.html"},{"type":"function","title":"erldns_handler.code_change/3","doc":null,"ref":"erldns_handler.html#code_change/3"},{"type":"function","title":"erldns_handler.do_handle/2","doc":null,"ref":"erldns_handler.html#do_handle/2"},{"type":"function","title":"erldns_handler.get_handlers/0","doc":"Get all registered handlers along with the DNS types they handle","ref":"erldns_handler.html#get_handlers/0"},{"type":"function","title":"erldns_handler.get_versioned_handlers/0","doc":"Get all registered handlers along with the DNS types they handle and associated versions","ref":"erldns_handler.html#get_versioned_handlers/0"},{"type":"function","title":"erldns_handler.handle/2","doc":null,"ref":"erldns_handler.html#handle/2"},{"type":"function","title":"erldns_handler.handle_call/3","doc":null,"ref":"erldns_handler.html#handle_call/3"},{"type":"function","title":"erldns_handler.handle_cast/2","doc":null,"ref":"erldns_handler.html#handle_cast/2"},{"type":"function","title":"erldns_handler.handle_info/2","doc":null,"ref":"erldns_handler.html#handle_info/2"},{"type":"function","title":"erldns_handler.handle_message/2","doc":null,"ref":"erldns_handler.html#handle_message/2"},{"type":"function","title":"erldns_handler.init/1","doc":null,"ref":"erldns_handler.html#init/1"},{"type":"function","title":"erldns_handler.register_handler/2","doc":"Register a record handler.","ref":"erldns_handler.html#register_handler/2"},{"type":"function","title":"erldns_handler.register_handler/3","doc":"Register a record handler with version.","ref":"erldns_handler.html#register_handler/3"},{"type":"function","title":"erldns_handler.start_link/0","doc":"Start the handler registry process.","ref":"erldns_handler.html#start_link/0"},{"type":"function","title":"erldns_handler.terminate/2","doc":null,"ref":"erldns_handler.html#terminate/2"},{"type":"module","title":"erldns_packet_cache","doc":"A basic packet cache that is used to avoid multiple lookups for the same question received within the cache TTL. The cache is swept for old cache data at regular intervals.","ref":"erldns_packet_cache.html"},{"type":"function","title":"erldns_packet_cache.clear/0","doc":"Clean the cache","ref":"erldns_packet_cache.html#clear/0"},{"type":"function","title":"erldns_packet_cache.code_change/3","doc":null,"ref":"erldns_packet_cache.html#code_change/3"},{"type":"function","title":"erldns_packet_cache.get/1","doc":"Try to retrieve a cached response for the given question.","ref":"erldns_packet_cache.html#get/1"},{"type":"function","title":"erldns_packet_cache.get/2","doc":"Try to retrieve a cached response for the given question sent by the given host.","ref":"erldns_packet_cache.html#get/2"},{"type":"function","title":"erldns_packet_cache.handle_call/3","doc":null,"ref":"erldns_packet_cache.html#handle_call/3"},{"type":"function","title":"erldns_packet_cache.handle_cast/2","doc":null,"ref":"erldns_packet_cache.html#handle_cast/2"},{"type":"function","title":"erldns_packet_cache.handle_info/2","doc":null,"ref":"erldns_packet_cache.html#handle_info/2"},{"type":"function","title":"erldns_packet_cache.init/1","doc":null,"ref":"erldns_packet_cache.html#init/1"},{"type":"function","title":"erldns_packet_cache.put/2","doc":"Put the response in the cache for the given question.","ref":"erldns_packet_cache.html#put/2"},{"type":"function","title":"erldns_packet_cache.start_link/0","doc":"Start the cache.","ref":"erldns_packet_cache.html#start_link/0"},{"type":"function","title":"erldns_packet_cache.stop/0","doc":"Stop the cache","ref":"erldns_packet_cache.html#stop/0"},{"type":"function","title":"erldns_packet_cache.sweep/0","doc":"Remove all old cached packets from the cache.","ref":"erldns_packet_cache.html#sweep/0"},{"type":"function","title":"erldns_packet_cache.terminate/2","doc":null,"ref":"erldns_packet_cache.html#terminate/2"},{"type":"module","title":"erldns_query_throttle","doc":"Stateful query throttling. Currently only throttles ANY queries. This throttling is useful for stopping DNS reflection/amplification attacks.","ref":"erldns_query_throttle.html"},{"type":"function","title":"erldns_query_throttle.code_change/3","doc":null,"ref":"erldns_query_throttle.html#code_change/3"},{"type":"function","title":"erldns_query_throttle.handle_call/3","doc":null,"ref":"erldns_query_throttle.html#handle_call/3"},{"type":"function","title":"erldns_query_throttle.handle_cast/2","doc":null,"ref":"erldns_query_throttle.html#handle_cast/2"},{"type":"function","title":"erldns_query_throttle.handle_info/2","doc":null,"ref":"erldns_query_throttle.html#handle_info/2"},{"type":"function","title":"erldns_query_throttle.init/1","doc":null,"ref":"erldns_query_throttle.html#init/1"},{"type":"function","title":"erldns_query_throttle.start_link/0","doc":"Start the query throttle process.","ref":"erldns_query_throttle.html#start_link/0"},{"type":"function","title":"erldns_query_throttle.stop/0","doc":"Stop the query throttle process normally.","ref":"erldns_query_throttle.html#stop/0"},{"type":"function","title":"erldns_query_throttle.sweep/0","doc":"Sweep the query throttle table for expired host records.","ref":"erldns_query_throttle.html#sweep/0"},{"type":"function","title":"erldns_query_throttle.terminate/2","doc":null,"ref":"erldns_query_throttle.html#terminate/2"},{"type":"function","title":"erldns_query_throttle.throttle/2","doc":"Throttle the given message if necessary.","ref":"erldns_query_throttle.html#throttle/2"},{"type":"type","title":"erldns_query_throttle.throttle_hit_count/0","doc":null,"ref":"erldns_query_throttle.html#t:throttle_hit_count/0"},{"type":"type","title":"erldns_query_throttle.throttle_result/0","doc":null,"ref":"erldns_query_throttle.html#t:throttle_result/0"},{"type":"module","title":"erldns_records","doc":null,"ref":"erldns_records.html"},{"type":"function","title":"erldns_records.default_priority/1","doc":"Return the Priority value or 0 if it is undefined.","ref":"erldns_records.html#default_priority/1"},{"type":"function","title":"erldns_records.default_ttl/1","doc":"Return the TTL value or 3600 if it is undefined.","ref":"erldns_records.html#default_ttl/1"},{"type":"function","title":"erldns_records.match_delegation/1","doc":null,"ref":"erldns_records.html#match_delegation/1"},{"type":"function","title":"erldns_records.match_name/1","doc":null,"ref":"erldns_records.html#match_name/1"},{"type":"function","title":"erldns_records.match_name_and_type/2","doc":null,"ref":"erldns_records.html#match_name_and_type/2"},{"type":"function","title":"erldns_records.match_type/1","doc":null,"ref":"erldns_records.html#match_type/1"},{"type":"function","title":"erldns_records.match_type_covered/1","doc":null,"ref":"erldns_records.html#match_type_covered/1"},{"type":"function","title":"erldns_records.match_types/1","doc":null,"ref":"erldns_records.html#match_types/1"},{"type":"function","title":"erldns_records.match_wildcard/0","doc":null,"ref":"erldns_records.html#match_wildcard/0"},{"type":"function","title":"erldns_records.minimum_soa_ttl/2","doc":"Applies a minimum TTL based on the SOA minimum value. The first argument is the Record that is being updated. The second argument is the SOA RR Data.","ref":"erldns_records.html#minimum_soa_ttl/2"},{"type":"function","title":"erldns_records.name_type/1","doc":"Returns the type value given a binary string.","ref":"erldns_records.html#name_type/1"},{"type":"function","title":"erldns_records.optionally_convert_wildcard/2","doc":"If given Name is a wildcard name then the original qname needs to be returned in its place.","ref":"erldns_records.html#optionally_convert_wildcard/2"},{"type":"function","title":"erldns_records.replace_name/1","doc":null,"ref":"erldns_records.html#replace_name/1"},{"type":"function","title":"erldns_records.rewrite_soa_ttl/1","doc":"According to RFC 2308 the TTL for the SOA record in an NXDOMAIN response must be set to the value of the minimum field in the SOA content.","ref":"erldns_records.html#rewrite_soa_ttl/1"},{"type":"function","title":"erldns_records.root_hints/0","doc":null,"ref":"erldns_records.html#root_hints/0"},{"type":"function","title":"erldns_records.wildcard_qname/1","doc":"Get a wildcard variation of a Qname. Replaces the leading abel with an asterisk for wildcard lookup.","ref":"erldns_records.html#wildcard_qname/1"},{"type":"module","title":"erldns_resolver","doc":"Resolve a DNS query.","ref":"erldns_resolver.html"},{"type":"function","title":"erldns_resolver.best_match/2","doc":null,"ref":"erldns_resolver.html#best_match/2"},{"type":"function","title":"erldns_resolver.resolve/3","doc":"Resolve the first question in the message. If no message is present, return the original message. If multiple questions are present, only resolve the first question.","ref":"erldns_resolver.html#resolve/3"},{"type":"module","title":"erldns_server_sup","doc":"The general server supervisor. Starts the UDP and TCP listers on both IPv4 and IPv6 ports. Also runs the zone checker *after* the UDP and TCP servers are running.","ref":"erldns_server_sup.html"},{"type":"function","title":"erldns_server_sup.init/1","doc":null,"ref":"erldns_server_sup.html#init/1"},{"type":"function","title":"erldns_server_sup.start_link/0","doc":null,"ref":"erldns_server_sup.html#start_link/0"},{"type":"module","title":"erldns_storage","doc":"API for a module's function calls. Please note that all crashes should be handled at the lowest level of the API (ex. erldns_storage_json).","ref":"erldns_storage.html"},{"type":"function","title":"erldns_storage.backup_table/1","doc":"Backup the table to the JSON file. https://github.com/SiftLogic/erl-dns/issues/3","ref":"erldns_storage.html#backup_table/1"},{"type":"function","title":"erldns_storage.backup_tables/0","doc":"Backup the tables to the JSON file. https://github.com/SiftLogic/erl-dns/issues/3","ref":"erldns_storage.html#backup_tables/0"},{"type":"function","title":"erldns_storage.code_change/3","doc":null,"ref":"erldns_storage.html#code_change/3"},{"type":"function","title":"erldns_storage.create/1","doc":"Call to a module's create. Creates a new table.","ref":"erldns_storage.html#create/1"},{"type":"function","title":"erldns_storage.delete/2","doc":"Call to a module's delete. Deletes a key value from a table.","ref":"erldns_storage.html#delete/2"},{"type":"function","title":"erldns_storage.delete_table/1","doc":"Call to a module's delete_table. Deletes the entire table.","ref":"erldns_storage.html#delete_table/1"},{"type":"function","title":"erldns_storage.empty_table/1","doc":"This function emptys the specified table of all values.","ref":"erldns_storage.html#empty_table/1"},{"type":"function","title":"erldns_storage.foldl/3","doc":"Call to a module's foldl.","ref":"erldns_storage.html#foldl/3"},{"type":"function","title":"erldns_storage.handle_call/3","doc":null,"ref":"erldns_storage.html#handle_call/3"},{"type":"function","title":"erldns_storage.handle_cast/2","doc":null,"ref":"erldns_storage.html#handle_cast/2"},{"type":"function","title":"erldns_storage.handle_info/2","doc":"Backups the tables in the given period","ref":"erldns_storage.html#handle_info/2"},{"type":"function","title":"erldns_storage.init/1","doc":"Inits the module, and sends a &quot;timeout&quot; to handle_info to start the poller for table backup","ref":"erldns_storage.html#init/1"},{"type":"function","title":"erldns_storage.insert/2","doc":"Call to a module's insert. Inserts a value into the table.","ref":"erldns_storage.html#insert/2"},{"type":"function","title":"erldns_storage.list_table/1","doc":"List all elements in a table.","ref":"erldns_storage.html#list_table/1"},{"type":"function","title":"erldns_storage.load_zones/0","doc":"Load zones from a file. The default file name is &quot;zones.json&quot;.(copied from erldns_zone_loader.erl)","ref":"erldns_storage.html#load_zones/0"},{"type":"function","title":"erldns_storage.load_zones/1","doc":"Load zones from a file. The default file name is &quot;zones.json&quot;.(copied from erldns_zone_loader.erl)","ref":"erldns_storage.html#load_zones/1"},{"type":"function","title":"erldns_storage.select/2","doc":"Call to a module's select. Uses table key pair, and can be considered a &quot;lookup&quot; in terms of ets.","ref":"erldns_storage.html#select/2"},{"type":"function","title":"erldns_storage.select/3","doc":"Call to a module's select/3 Uses a matchspec to generate matches.","ref":"erldns_storage.html#select/3"},{"type":"function","title":"erldns_storage.select_delete/2","doc":null,"ref":"erldns_storage.html#select_delete/2"},{"type":"function","title":"erldns_storage.start_link/0","doc":null,"ref":"erldns_storage.html#start_link/0"},{"type":"function","title":"erldns_storage.terminate/2","doc":null,"ref":"erldns_storage.html#terminate/2"},{"type":"module","title":"erldns_storage_json","doc":null,"ref":"erldns_storage_json.html"},{"type":"function","title":"erldns_storage_json.backup_table/1","doc":"Backup a specific ets table. https://github.com/SiftLogic/erl-dns/issues/3","ref":"erldns_storage_json.html#backup_table/1"},{"type":"function","title":"erldns_storage_json.backup_tables/0","doc":"Should backup all ets tables. https://github.com/SiftLogic/erl-dns/issues/3","ref":"erldns_storage_json.html#backup_tables/0"},{"type":"function","title":"erldns_storage_json.create/1","doc":"Create ets table wrapper. Use match cases for adding different options to the table.","ref":"erldns_storage_json.html#create/1"},{"type":"function","title":"erldns_storage_json.delete/2","doc":"Delete an entry in the ets table.Ets always returns true for this function.","ref":"erldns_storage_json.html#delete/2"},{"type":"function","title":"erldns_storage_json.delete_table/1","doc":"Delete entire ets table.","ref":"erldns_storage_json.html#delete_table/1"},{"type":"function","title":"erldns_storage_json.empty_table/1","doc":"Empty ets table. Ets always returns true for this function.","ref":"erldns_storage_json.html#empty_table/1"},{"type":"function","title":"erldns_storage_json.foldl/3","doc":"Wrapper for foldl in ets.","ref":"erldns_storage_json.html#foldl/3"},{"type":"function","title":"erldns_storage_json.insert/2","doc":"Insert value in ets table.","ref":"erldns_storage_json.html#insert/2"},{"type":"function","title":"erldns_storage_json.list_table/1","doc":"Lists the ets table","ref":"erldns_storage_json.html#list_table/1"},{"type":"function","title":"erldns_storage_json.select/2","doc":"Select from ets using key, value.","ref":"erldns_storage_json.html#select/2"},{"type":"function","title":"erldns_storage_json.select/3","doc":null,"ref":"erldns_storage_json.html#select/3"},{"type":"function","title":"erldns_storage_json.select_delete/2","doc":"Delete entries in the ets table that match the provided spec.","ref":"erldns_storage_json.html#select_delete/2"},{"type":"module","title":"erldns_storage_mnesia","doc":null,"ref":"erldns_storage_mnesia.html"},{"type":"function","title":"erldns_storage_mnesia.backup_table/1","doc":"Should backup the tables in the schema. https://github.com/SiftLogic/erl-dns/issues/3","ref":"erldns_storage_mnesia.html#backup_table/1"},{"type":"function","title":"erldns_storage_mnesia.backup_tables/0","doc":null,"ref":"erldns_storage_mnesia.html#backup_tables/0"},{"type":"function","title":"erldns_storage_mnesia.create/1","doc":"Create the schema for mnesia, get the configuration from the config. Function sends 'ok' if schema is created, or if it already exists.","ref":"erldns_storage_mnesia.html#create/1"},{"type":"function","title":"erldns_storage_mnesia.delete/2","doc":"Delete a mnesia record, have to do things different for zones since we specified {record_name, zone} in the table creation.","ref":"erldns_storage_mnesia.html#delete/2"},{"type":"function","title":"erldns_storage_mnesia.delete_table/1","doc":"delete the entire table.","ref":"erldns_storage_mnesia.html#delete_table/1"},{"type":"function","title":"erldns_storage_mnesia.empty_table/1","doc":"Clear all objects from given table in mnesia DB.","ref":"erldns_storage_mnesia.html#empty_table/1"},{"type":"function","title":"erldns_storage_mnesia.foldl/3","doc":"Wrapper for foldl.","ref":"erldns_storage_mnesia.html#foldl/3"},{"type":"function","title":"erldns_storage_mnesia.insert/2","doc":"Insert into specified table. zone_cache calls this by {name, #zone{}}","ref":"erldns_storage_mnesia.html#insert/2"},{"type":"function","title":"erldns_storage_mnesia.list_table/1","doc":"Lists the contents of the given table.","ref":"erldns_storage_mnesia.html#list_table/1"},{"type":"function","title":"erldns_storage_mnesia.select/2","doc":"Select based on key value.","ref":"erldns_storage_mnesia.html#select/2"},{"type":"function","title":"erldns_storage_mnesia.select/3","doc":"Select using ETS match spec converted to Mnesia's match_object pattern","ref":"erldns_storage_mnesia.html#select/3"},{"type":"function","title":"erldns_storage_mnesia.select_delete/2","doc":"Delete all zone records or zone records typed based on the match spec. The match spec is given as an ETS match spec, thus it needs to be converted to a record match spec for Mnesia.","ref":"erldns_storage_mnesia.html#select_delete/2"},{"type":"module","title":"erldns_sup","doc":"Application supervisor. Supervises everything except the UDP and TCP listeners and the zone checker.","ref":"erldns_sup.html"},{"type":"function","title":"erldns_sup.gc/0","doc":"Garbage collect all processes.","ref":"erldns_sup.html#gc/0"},{"type":"function","title":"erldns_sup.gc_registered/0","doc":"Garbage collect all registered processes.","ref":"erldns_sup.html#gc_registered/0"},{"type":"function","title":"erldns_sup.gc_registered/1","doc":"Garbage collect a named process.","ref":"erldns_sup.html#gc_registered/1"},{"type":"function","title":"erldns_sup.init/1","doc":null,"ref":"erldns_sup.html#init/1"},{"type":"function","title":"erldns_sup.start_link/0","doc":null,"ref":"erldns_sup.html#start_link/0"},{"type":"module","title":"erldns_tcp_server","doc":"Handles DNS questions arriving via TCP.","ref":"erldns_tcp_server.html"},{"type":"function","title":"erldns_tcp_server.code_change/3","doc":null,"ref":"erldns_tcp_server.html#code_change/3"},{"type":"function","title":"erldns_tcp_server.handle_call/3","doc":null,"ref":"erldns_tcp_server.html#handle_call/3"},{"type":"function","title":"erldns_tcp_server.handle_cast/2","doc":null,"ref":"erldns_tcp_server.html#handle_cast/2"},{"type":"function","title":"erldns_tcp_server.handle_info/2","doc":null,"ref":"erldns_tcp_server.html#handle_info/2"},{"type":"function","title":"erldns_tcp_server.handle_request/3","doc":null,"ref":"erldns_tcp_server.html#handle_request/3"},{"type":"function","title":"erldns_tcp_server.init/1","doc":null,"ref":"erldns_tcp_server.html#init/1"},{"type":"function","title":"erldns_tcp_server.new_connection/2","doc":null,"ref":"erldns_tcp_server.html#new_connection/2"},{"type":"function","title":"erldns_tcp_server.sock_opts/0","doc":null,"ref":"erldns_tcp_server.html#sock_opts/0"},{"type":"function","title":"erldns_tcp_server.start_link/2","doc":null,"ref":"erldns_tcp_server.html#start_link/2"},{"type":"function","title":"erldns_tcp_server.start_link/4","doc":null,"ref":"erldns_tcp_server.html#start_link/4"},{"type":"function","title":"erldns_tcp_server.terminate/2","doc":null,"ref":"erldns_tcp_server.html#terminate/2"},{"type":"module","title":"erldns_txt","doc":"Functions related to TXT record parsing.","ref":"erldns_txt.html"},{"type":"function","title":"erldns_txt.parse/1","doc":"Parse a string into a collection of bit strings, each no longer than 255 characters.","ref":"erldns_txt.html#parse/1"},{"type":"module","title":"erldns_udp_server","doc":"Handles DNS questions arriving via UDP.","ref":"erldns_udp_server.html"},{"type":"function","title":"erldns_udp_server.code_change/3","doc":null,"ref":"erldns_udp_server.html#code_change/3"},{"type":"function","title":"erldns_udp_server.handle_call/3","doc":null,"ref":"erldns_udp_server.html#handle_call/3"},{"type":"function","title":"erldns_udp_server.handle_cast/2","doc":null,"ref":"erldns_udp_server.html#handle_cast/2"},{"type":"function","title":"erldns_udp_server.handle_info/2","doc":null,"ref":"erldns_udp_server.html#handle_info/2"},{"type":"function","title":"erldns_udp_server.handle_request/5","doc":null,"ref":"erldns_udp_server.html#handle_request/5"},{"type":"function","title":"erldns_udp_server.init/1","doc":null,"ref":"erldns_udp_server.html#init/1"},{"type":"function","title":"erldns_udp_server.is_running/0","doc":"Return true if the UDP server process is running","ref":"erldns_udp_server.html#is_running/0"},{"type":"function","title":"erldns_udp_server.start_link/2","doc":"Start the UDP server process","ref":"erldns_udp_server.html#start_link/2"},{"type":"function","title":"erldns_udp_server.start_link/4","doc":null,"ref":"erldns_udp_server.html#start_link/4"},{"type":"function","title":"erldns_udp_server.start_link/5","doc":null,"ref":"erldns_udp_server.html#start_link/5"},{"type":"function","title":"erldns_udp_server.terminate/2","doc":null,"ref":"erldns_udp_server.html#terminate/2"},{"type":"module","title":"erldns_worker","doc":"Worker module that asynchronously accepts a single DNS packet and hands it to a worker process that has a set timeout.","ref":"erldns_worker.html"},{"type":"function","title":"erldns_worker.code_change/3","doc":null,"ref":"erldns_worker.html#code_change/3"},{"type":"function","title":"erldns_worker.handle_call/3","doc":null,"ref":"erldns_worker.html#handle_call/3"},{"type":"function","title":"erldns_worker.handle_cast/2","doc":null,"ref":"erldns_worker.html#handle_cast/2"},{"type":"function","title":"erldns_worker.handle_info/2","doc":null,"ref":"erldns_worker.html#handle_info/2"},{"type":"function","title":"erldns_worker.init/1","doc":null,"ref":"erldns_worker.html#init/1"},{"type":"function","title":"erldns_worker.start_link/1","doc":null,"ref":"erldns_worker.html#start_link/1"},{"type":"function","title":"erldns_worker.terminate/2","doc":null,"ref":"erldns_worker.html#terminate/2"},{"type":"module","title":"erldns_worker_process","doc":"Worker module that processes a single DNS packet.","ref":"erldns_worker_process.html"},{"type":"function","title":"erldns_worker_process.code_change/3","doc":null,"ref":"erldns_worker_process.html#code_change/3"},{"type":"function","title":"erldns_worker_process.handle_call/3","doc":null,"ref":"erldns_worker_process.html#handle_call/3"},{"type":"function","title":"erldns_worker_process.handle_cast/2","doc":null,"ref":"erldns_worker_process.html#handle_cast/2"},{"type":"function","title":"erldns_worker_process.handle_info/2","doc":null,"ref":"erldns_worker_process.html#handle_info/2"},{"type":"function","title":"erldns_worker_process.init/1","doc":null,"ref":"erldns_worker_process.html#init/1"},{"type":"function","title":"erldns_worker_process.start_link/1","doc":null,"ref":"erldns_worker_process.html#start_link/1"},{"type":"function","title":"erldns_worker_process.terminate/2","doc":null,"ref":"erldns_worker_process.html#terminate/2"},{"type":"module","title":"erldns_worker_process_sup","doc":"Supervisor that allows terminate and restart of an erldns_worker_process that is attached to an erldns_worker.","ref":"erldns_worker_process_sup.html"},{"type":"function","title":"erldns_worker_process_sup.init/1","doc":null,"ref":"erldns_worker_process_sup.html#init/1"},{"type":"function","title":"erldns_worker_process_sup.start_link/1","doc":null,"ref":"erldns_worker_process_sup.html#start_link/1"},{"type":"module","title":"erldns_zone_cache","doc":"A cache holding all of the zone data. Write operations occur through the cache process mailbox, whereas read operations may occur either through the mailbox or directly through the underlying data store, depending on performance requirements.","ref":"erldns_zone_cache.html"},{"type":"function","title":"erldns_zone_cache.code_change/3","doc":null,"ref":"erldns_zone_cache.html#code_change/3"},{"type":"function","title":"erldns_zone_cache.delete_zone/1","doc":"Remove a zone from the cache without waiting for a response.","ref":"erldns_zone_cache.html#delete_zone/1"},{"type":"function","title":"erldns_zone_cache.delete_zone_rrset/5","doc":"Remove zone RRSet","ref":"erldns_zone_cache.html#delete_zone_rrset/5"},{"type":"function","title":"erldns_zone_cache.find_zone/1","doc":"Find a zone for a given qname.","ref":"erldns_zone_cache.html#find_zone/1"},{"type":"function","title":"erldns_zone_cache.find_zone/2","doc":"Find a zone for a given qname.","ref":"erldns_zone_cache.html#find_zone/2"},{"type":"function","title":"erldns_zone_cache.get_authority/1","doc":"Find the SOA record for the given DNS question.","ref":"erldns_zone_cache.html#get_authority/1"},{"type":"function","title":"erldns_zone_cache.get_delegations/1","doc":"Get the list of NS and glue records for the given name. This function will always return a list, even if it is empty.","ref":"erldns_zone_cache.html#get_delegations/1"},{"type":"function","title":"erldns_zone_cache.get_records_by_name/1","doc":"Return the record set for the given dname.","ref":"erldns_zone_cache.html#get_records_by_name/1"},{"type":"function","title":"erldns_zone_cache.get_records_by_name_and_type/2","doc":"Get all records for the given type and given name.","ref":"erldns_zone_cache.html#get_records_by_name_and_type/2"},{"type":"function","title":"erldns_zone_cache.get_rrset_sync_counter/3","doc":"Return current sync counter","ref":"erldns_zone_cache.html#get_rrset_sync_counter/3"},{"type":"function","title":"erldns_zone_cache.get_zone/1","doc":"Get a zone for the specific name. This function will not attempt to resolve the dname in any way, it will simply look up the name in the underlying data store.","ref":"erldns_zone_cache.html#get_zone/1"},{"type":"function","title":"erldns_zone_cache.get_zone_records/1","doc":"Get all records for the given zone.","ref":"erldns_zone_cache.html#get_zone_records/1"},{"type":"function","title":"erldns_zone_cache.get_zone_with_records/1","doc":"Get a zone for the specific name, including the records for the zone.","ref":"erldns_zone_cache.html#get_zone_with_records/1"},{"type":"function","title":"erldns_zone_cache.handle_call/3","doc":null,"ref":"erldns_zone_cache.html#handle_call/3"},{"type":"function","title":"erldns_zone_cache.handle_cast/2","doc":null,"ref":"erldns_zone_cache.html#handle_cast/2"},{"type":"function","title":"erldns_zone_cache.handle_info/2","doc":null,"ref":"erldns_zone_cache.html#handle_info/2"},{"type":"function","title":"erldns_zone_cache.in_zone/1","doc":"Check if the name is in a zone.","ref":"erldns_zone_cache.html#in_zone/1"},{"type":"function","title":"erldns_zone_cache.init/1","doc":"Initialize the zone cache.","ref":"erldns_zone_cache.html#init/1"},{"type":"function","title":"erldns_zone_cache.put_zone/1","doc":"Put a name and its records into the cache, along with a SHA which can be used to determine if the zone requires updating. This function will build the necessary Zone record before inserting.","ref":"erldns_zone_cache.html#put_zone/1"},{"type":"function","title":"erldns_zone_cache.put_zone/2","doc":"Put a zone into the cache and wait for a response.","ref":"erldns_zone_cache.html#put_zone/2"},{"type":"function","title":"erldns_zone_cache.put_zone_rrset/4","doc":"Put zone RRSet","ref":"erldns_zone_cache.html#put_zone_rrset/4"},{"type":"function","title":"erldns_zone_cache.record_name_in_zone/2","doc":"Check if the record name is in the zone. Will also return true if a wildcard is present at the node.","ref":"erldns_zone_cache.html#record_name_in_zone/2"},{"type":"function","title":"erldns_zone_cache.start_link/0","doc":"Start the zone cache process.","ref":"erldns_zone_cache.html#start_link/0"},{"type":"function","title":"erldns_zone_cache.terminate/2","doc":null,"ref":"erldns_zone_cache.html#terminate/2"},{"type":"function","title":"erldns_zone_cache.update_zone_records_and_digest/3","doc":"Given a zone name, list of records, and a digest, update the zone metadata in cache.","ref":"erldns_zone_cache.html#update_zone_records_and_digest/3"},{"type":"function","title":"erldns_zone_cache.zone_names_and_versions/0","doc":"Return a list of tuples with each tuple as a name and the version SHA for the zone.","ref":"erldns_zone_cache.html#zone_names_and_versions/0"},{"type":"module","title":"erldns_zone_encoder","doc":"A process that maintains a collection of encoders in its state for encoding zones from their Erlang representation to JSON.","ref":"erldns_zone_encoder.html"},{"type":"function","title":"erldns_zone_encoder.code_change/3","doc":null,"ref":"erldns_zone_encoder.html#code_change/3"},{"type":"function","title":"erldns_zone_encoder.handle_call/3","doc":null,"ref":"erldns_zone_encoder.html#handle_call/3"},{"type":"function","title":"erldns_zone_encoder.handle_cast/2","doc":null,"ref":"erldns_zone_encoder.html#handle_cast/2"},{"type":"function","title":"erldns_zone_encoder.handle_info/2","doc":null,"ref":"erldns_zone_encoder.html#handle_info/2"},{"type":"function","title":"erldns_zone_encoder.init/1","doc":null,"ref":"erldns_zone_encoder.html#init/1"},{"type":"function","title":"erldns_zone_encoder.register_encoder/1","doc":"Register a single encoder module.","ref":"erldns_zone_encoder.html#register_encoder/1"},{"type":"function","title":"erldns_zone_encoder.register_encoders/1","doc":"Register a list of encoder modules.","ref":"erldns_zone_encoder.html#register_encoders/1"},{"type":"function","title":"erldns_zone_encoder.start_link/0","doc":"Start the encoder process.","ref":"erldns_zone_encoder.html#start_link/0"},{"type":"function","title":"erldns_zone_encoder.terminate/2","doc":null,"ref":"erldns_zone_encoder.html#terminate/2"},{"type":"function","title":"erldns_zone_encoder.zone_meta_to_json/1","doc":"Encode a Zone meta data into JSON.","ref":"erldns_zone_encoder.html#zone_meta_to_json/1"},{"type":"function","title":"erldns_zone_encoder.zone_records_to_json/2","doc":"Encode the records in the zone with the given RRSet name and type into JSON","ref":"erldns_zone_encoder.html#zone_records_to_json/2"},{"type":"function","title":"erldns_zone_encoder.zone_records_to_json/3","doc":"Encode the records in the zone with the given RRSet name and type into JSON","ref":"erldns_zone_encoder.html#zone_records_to_json/3"},{"type":"function","title":"erldns_zone_encoder.zone_to_json/1","doc":"Encode a Zone meta data plus all of its records into JSON.","ref":"erldns_zone_encoder.html#zone_to_json/1"},{"type":"module","title":"erldns_zone_loader","doc":"Functions for loading zones from local or remote sources.","ref":"erldns_zone_loader.html"},{"type":"function","title":"erldns_zone_loader.load_zones/0","doc":"Load zones from a file. The default file name is &quot;zones.json&quot;.","ref":"erldns_zone_loader.html#load_zones/0"},{"type":"module","title":"erldns_zone_parser","doc":"Process for parsing zone data from JSON to Erlang representations.","ref":"erldns_zone_parser.html"},{"type":"function","title":"erldns_zone_parser.code_change/3","doc":null,"ref":"erldns_zone_parser.html#code_change/3"},{"type":"function","title":"erldns_zone_parser.handle_call/3","doc":null,"ref":"erldns_zone_parser.html#handle_call/3"},{"type":"function","title":"erldns_zone_parser.handle_cast/2","doc":null,"ref":"erldns_zone_parser.html#handle_cast/2"},{"type":"function","title":"erldns_zone_parser.handle_info/2","doc":null,"ref":"erldns_zone_parser.html#handle_info/2"},{"type":"function","title":"erldns_zone_parser.init/1","doc":null,"ref":"erldns_zone_parser.html#init/1"},{"type":"function","title":"erldns_zone_parser.list_parsers/0","doc":null,"ref":"erldns_zone_parser.html#list_parsers/0"},{"type":"function","title":"erldns_zone_parser.register_parser/1","doc":"Register a custom parser module.","ref":"erldns_zone_parser.html#register_parser/1"},{"type":"function","title":"erldns_zone_parser.register_parsers/1","doc":"Register a list of custom parser modules.","ref":"erldns_zone_parser.html#register_parsers/1"},{"type":"function","title":"erldns_zone_parser.start_link/0","doc":"Start the parser processor.","ref":"erldns_zone_parser.html#start_link/0"},{"type":"function","title":"erldns_zone_parser.terminate/2","doc":null,"ref":"erldns_zone_parser.html#terminate/2"},{"type":"function","title":"erldns_zone_parser.zone_to_erlang/1","doc":"Takes a JSON zone and turns it into the tuple {Name, Sha, Records}. The default timeout for parsing is currently 30 seconds.","ref":"erldns_zone_parser.html#zone_to_erlang/1"},{"type":"function","title":"erldns_zone_parser.zone_to_erlang/2","doc":null,"ref":"erldns_zone_parser.html#zone_to_erlang/2"},{"type":"behaviour","title":"gen_nb_server","doc":null,"ref":"gen_nb_server.html"},{"type":"callback","title":"gen_nb_server.handle_call/3","doc":null,"ref":"gen_nb_server.html#c:handle_call/3"},{"type":"callback","title":"gen_nb_server.handle_cast/2","doc":null,"ref":"gen_nb_server.html#c:handle_cast/2"},{"type":"callback","title":"gen_nb_server.handle_info/2","doc":null,"ref":"gen_nb_server.html#c:handle_info/2"},{"type":"callback","title":"gen_nb_server.init/1","doc":null,"ref":"gen_nb_server.html#c:init/1"},{"type":"callback","title":"gen_nb_server.new_connection/2","doc":null,"ref":"gen_nb_server.html#c:new_connection/2"},{"type":"callback","title":"gen_nb_server.sock_opts/0","doc":null,"ref":"gen_nb_server.html#c:sock_opts/0"},{"type":"function","title":"gen_nb_server.start_link/4","doc":"Start server listening on IpAddr:Port","ref":"gen_nb_server.html#start_link/4"},{"type":"callback","title":"gen_nb_server.terminate/2","doc":null,"ref":"gen_nb_server.html#c:terminate/2"},{"type":"type","title":"gen_nb_server.state/0","doc":null,"ref":"gen_nb_server.html#t:state/0"},{"type":"module","title":"sample_custom_handler","doc":"Example of a custom handler.","ref":"sample_custom_handler.html"},{"type":"function","title":"sample_custom_handler.code_change/3","doc":null,"ref":"sample_custom_handler.html#code_change/3"},{"type":"function","title":"sample_custom_handler.filter/1","doc":null,"ref":"sample_custom_handler.html#filter/1"},{"type":"function","title":"sample_custom_handler.handle/4","doc":null,"ref":"sample_custom_handler.html#handle/4"},{"type":"function","title":"sample_custom_handler.handle_call/3","doc":null,"ref":"sample_custom_handler.html#handle_call/3"},{"type":"function","title":"sample_custom_handler.handle_cast/2","doc":null,"ref":"sample_custom_handler.html#handle_cast/2"},{"type":"function","title":"sample_custom_handler.handle_info/2","doc":null,"ref":"sample_custom_handler.html#handle_info/2"},{"type":"function","title":"sample_custom_handler.init/1","doc":null,"ref":"sample_custom_handler.html#init/1"},{"type":"function","title":"sample_custom_handler.nsec_rr_type_mapper/1","doc":null,"ref":"sample_custom_handler.html#nsec_rr_type_mapper/1"},{"type":"function","title":"sample_custom_handler.start_link/0","doc":null,"ref":"sample_custom_handler.html#start_link/0"},{"type":"function","title":"sample_custom_handler.terminate/2","doc":null,"ref":"sample_custom_handler.html#terminate/2"},{"type":"module","title":"sample_custom_zone_encoder","doc":"Sample custom encoder.","ref":"sample_custom_zone_encoder.html"},{"type":"function","title":"sample_custom_zone_encoder.encode_record/1","doc":null,"ref":"sample_custom_zone_encoder.html#encode_record/1"},{"type":"module","title":"sample_custom_zone_parser","doc":"Sample custom zone parser.","ref":"sample_custom_zone_parser.html"},{"type":"function","title":"sample_custom_zone_parser.json_record_to_erlang/1","doc":null,"ref":"sample_custom_zone_parser.html#json_record_to_erlang/1"},{"type":"module","title":"t","doc":null,"ref":"t.html"},{"type":"function","title":"t.t/2","doc":null,"ref":"t.html#t/2"},{"type":"extras","title":"Overview","doc":"# Erlang DNS Server\n\nServe DNS authoritative responses... with Erlang.\n\n[![Build Status](https://github.com/dnsimple/erldns/actions/workflows/ci.yml/badge.svg)](https://github.com/dnsimple/erldns/actions/workflows/ci.yml)\n[![Module Version](https://img.shields.io/hexpm/v/erldns.svg)](https://hex.pm/packages/erldns)","ref":"readme.html"},{"type":"extras","title":"Requirements - Overview","doc":"Erlang/OTP 27+","ref":"readme.html#requirements"},{"type":"extras","title":"Building - Overview","doc":"To build:\n\n```shell\nmake\n```\n\nTo start fresh:\n\n```shell\nmake fresh\nmake\n```","ref":"readme.html#building"},{"type":"extras","title":"Zones - Overview","doc":"Zones are loaded from JSON. Example JSON files are in the `priv/` directory.\n\nYou can also write new systems to load zones by writing the zones directly to the zone cache using `erldns_zone_cache:put_zone/1`.","ref":"readme.html#zones"},{"type":"extras","title":"Configuration - Overview","doc":"An example configuration file can be found in `erldns.example.config`. Copy it to `erldns.config` and modify as needed.","ref":"readme.html#configuration"},{"type":"extras","title":"Running - Overview","doc":"","ref":"readme.html#running"},{"type":"extras","title":"Launch directly - Overview","doc":"```shell\novermind start\n```","ref":"readme.html#launch-directly"},{"type":"extras","title":"To get an interactive Erlang REPL - Overview","doc":"```shell\n./rebar3 shell\n```","ref":"readme.html#to-get-an-interactive-erlang-repl"},{"type":"extras","title":"Build a distribution with and run the release - Overview","doc":"```shell\n./rebar3 release\n./_build/default/rel/erldns/bin/erldns foreground\n```","ref":"readme.html#build-a-distribution-with-and-run-the-release"},{"type":"extras","title":"Querying - Overview","doc":"Here are some queries to try:\n\n```bash\ndig -p 8053 @127.0.0.1 example.com a\ndig -p 8053 @127.0.0.1 example.com cname\ndig -p 8053 @127.0.0.1 example.com ns\ndig -p 8053 @127.0.0.1 example.com mx\ndig -p 8053 @127.0.0.1 example.com spf\ndig -p 8053 @127.0.0.1 example.com txt\ndig -p 8053 @127.0.0.1 example.com sshfp\ndig -p 8053 @127.0.0.1 example.com soa\ndig -p 8053 @127.0.0.1 example.com naptr\n\ndig -p 8053 @127.0.0.1 -x 127.0.0.1 ptr\n```","ref":"readme.html#querying"},{"type":"extras","title":"Performance - Overview","doc":"In our environment (DNSimple) we are seeing 30 to 65 µs handoff times to retrieve a packet from the UDP port and give it to a worker for processing. Your performance may vary, but given those measurements erl-dns is capable of handling between 15k and 30k questions per second. Please note: You may need to configure the number of workers available to handle traffic at higher volumes.\n\nIf you want to perform some benchmarks, see [`BENCHMARKING.md`](./BENCHMARKING.md).","ref":"readme.html#performance"},{"type":"extras","title":"Design - Overview","doc":"The `erldns_resolver` module will attempt to find zone data in the zone cache. If you're embedding erl-dns in your application the easiest thing to do is to load the zone cache once the zone cache `gen_server` starts push an updated zone into the cache each time data changes.\n\nTo insert a zone, use `erldns_zone_cache:put_zone({Name, Records})` where Name is a binary term such as <<\"example.com\">> and Records is a list of `dns_rr` records (whose definitions can be found in `deps/dns/include/dns_records.hrl`). The name of each record must be the fully qualified domain name (including the zone part).\n\nHere's an example:\n\n```erlang\nerldns_zone_cache:put_zone({\n  <<\"example.com\">>, [\n    #dns_rr{\n      name = <<\"example.com\">>,\n      type = ?DNS_TYPE_A,\n      ttl = 3600,\n      data = #dns_rrdata_a{ip = {1,2,3,4}}\n    },\n    #dns_rr{\n      name = <<\"www.example.com\">>,\n      type = ?DNS_TYPE_CNAME,\n      ttl = 3600,\n      data = #dns_rrdata_cname{dname = <<\"example.com\">>}\n    }\n  ]}).\n```","ref":"readme.html#design"},{"type":"extras","title":"AXFR Support - Overview","doc":"AXFR zone transfers are not currently implemented. The current \"implementation\" is just a stub.","ref":"readme.html#axfr-support"},{"type":"extras","title":"Metrics - Overview","doc":"Folsom is used to gather runtime metrics and statistics.\n\nThere is an HTTP API for querying metric data available at","ref":"readme.html#metrics"},{"type":"extras","title":"Admin - Overview","doc":"There is an administrative API for querying the current zone cache and for basic control. You can find it in  .","ref":"readme.html#admin"},{"type":"extras","title":"Tests - Overview","doc":"To run automated tests:\n\n```shell\nmake test\n```\n\nThis runs both [EUnit](https://www.erlang.org/doc/apps/eunit/chapter.html) tests and [dialyzer](https://www.erlang.org/docs/23/man/dialyzer.html).","ref":"readme.html#tests"},{"type":"extras","title":"License","doc":"# Copyright (c) 2012-2025 DNSimple Corporation\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the \"Software\"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}